Namespaces
Variants
Views
Actions

std::uncaught_exception

From cppreference.com
< cpp‎ | error
 
 
 
Error handling
Exception handling
uncaught_exception
Exception handling failures
(deprecated)
(deprecated)
(C++11)(deprecated)
(deprecated)
Exception categories
Error codes
Error codes
Assertions
system_error facility
(C++11)
(C++11)
 
Defined in header <exception>
bool uncaught_exception();
(1) (deprecated in C++17)
int uncaught_exceptions();
(2) (since C++17)
1) Detects if the current thread has a live exception object, that is, an exception has been thrown or rethrown and not yet entered a matching catch clause, std::terminate or std::unexpected. In other words, std::uncaught_exception detects if stack unwinding is currently in progress.
2) Detects how many exceptions have been thrown or rethrown and not yet entered their matching catch clauses.

Sometimes it's safe to throw an exception even while std::uncaught_exception() == true. For example, if stack unwinding causes a stack-allocated object to be destructed, the destructor for that object could run code that throws an exception as long as the exception is caught by some catch block before escaping the destructor.

Contents

[edit] Parameters

(none)

[edit] Return value

1) true if stack unwinding is currently in progress in this thread.
2) The number of exception objects currently uncaught.

[edit] Exceptions

(none) (until C++11)
noexcept specification:  
noexcept
  
(since C++11)

[edit] Example

#include <iostream>
#include <exception>
#include <stdexcept>
 
struct Foo {
    ~Foo() {
        if (std::uncaught_exception()) {
            std::cout << "~Foo() called during stack unwinding\n";
        } else {
            std::cout << "~Foo() called normally\n";
        }
    }
};
int main()
{
    Foo f;
    try {
        Foo f;
        std::cout << "Exception thrown\n";
        throw std::runtime_error("test exception");
    } catch (const std::exception& e) {
        std::cout << "Exception caught: " << e.what() << '\n';
    }
}

Output:

Exception thrown
~Foo() called during stack unwinding
Exception caught: test exception
~Foo() called normally

[edit] See also

function called when exception handling fails
(function) [edit]
shared pointer type for handling exception objects
(typedef) [edit]

[edit] External links

GOTW issue 47: Uncaught Exceptions